#include "NodeVisitor.h"
#include "ExpDAG.h"


NodeVisitor::NodeVisitor()
{
}

NodeVisitor::~NodeVisitor()
{
}



void NodeVisitor::process(ExpDAG& bdag){
	int i=0;
	tmpdag = &bdag;
	for(ExpDAG::iterator node_it = bdag.begin(); node_it != bdag.end(); ++node_it, ++i){
		try{
		Dout(cout<<(*node_it)->get_name()<<":"<<(*node_it)->id<<endl);
		(*node_it)->accept(*this);
		}catch(BasicError& be){
			throw BasicError((*node_it)->get_namestr(), "ERROR WAS IN THE FOLLOWING NODE");      		
    	}
	}
}

void NodeVisitor::visitBool(ExpNode& node ){
	rvalue = &node;
}

void NodeVisitor::visit( AndNode& node ){
	visitBool(node);
}
void NodeVisitor::visit( OrNode& node ){
	visitBool(node);
}
void NodeVisitor::visit( NOT_node& node ){
	visitBool(node);	
}
void NodeVisitor::visit( PlusNode& node ){
	visitBool(node);	
}
void NodeVisitor::visit( TimesNode& node ){
	visitBool(node);	
}
void NodeVisitor::visit( DivNode& node ){
	visitBool(node);	
}
void NodeVisitor::visit( NEG_node& node ){
	visitBool(node);	
}
void NodeVisitor::visit( ConstNode& node ){
	visitBool(node);	
}
void NodeVisitor::visit( BoolNode& node ) {
  visitBool(node);
}
void NodeVisitor::visit( RelationNode& node) {
  visitBool(node);
}
void NodeVisitor::visit( RecordNode& node) {
  visitBool(node);
}
void NodeVisitor::visit( SymNode& node ) {
  visitBool(node);
}
void NodeVisitor::visit( TernaryNode& node ) {
  visitBool(node);
}
void NodeVisitor::visit( GtNode& node ){
	visitBool(node);	
}
void NodeVisitor::visit( GeNode& node ){
	visitBool(node);	
}
void NodeVisitor::visit( LtNode& node ){
	visitBool(node);	
}
void NodeVisitor::visit( LeNode& node ){
	visitBool(node);	
}
void NodeVisitor::visit( EqNode& node ){
	visitBool(node);	
}
void NodeVisitor::visit( NeqNode& node ){
	visitBool(node);
}
void NodeVisitor::visit( AssertNode &node){
	visitBool(node);	
}	

