#include <caml/mlvalues.h>
#include "BackendRep/backend_defs.h"

void assertExpEnv();
void writeEnvAssertions();
void resolveWithEnvContext();

/**
 * This function calls the backend function that adds the current expression
 * to the list of assertions.
 */
CAMLprim void assertExp() {
  assertExpEnv();
}

CAMLprim void writeAssertions() {
  writeEnvAssertions();
}

CAMLprim void resolveWithContext(value ctxt) {
  resolveWithEnvContext(Int_val(ctxt));
}
