open Ast

module ConstraintSimplify :
  sig
    val cexp_eq : Ast.cexp ref -> Ast.cexp ref -> int
    val mkACAnd : Ast.cexp ref -> Ast.cexp ref -> Ast.cexp ref
    val csimplify : Ast.cexp ref -> Ast.cexp ref
  end

module ConstraintConverter :
  sig
    val ast2constraint : Ast.exp ref -> Ast.cexp ref
    val convert_constraints : Ast.cexp ref list -> string list
  end

module ConstraintPrinter :
  sig
    val pickle_exp : Ast.cexp ref -> string list
    val print_cexps : Ast.cexp ref list -> unit list
  end
