import popen2
import random

def writeFile(filename, len, fraction_missing):
  f = open (filename, 'w')
  for i in range(0, len):
    num = random.randint(0, len)
    if random.random() < fraction_missing:
      ts = "!!"
    else:
      ts = str(i)
    line = ts + " 200\n"
    f.write(line)
  f.close()

def callYices():
  (stdout, _) = popen2.popen2("./driver -file tests/sort.sp")
  lines = stdout.readlines()
  return float(lines[0])

def main():
  for i in range(5, 15):
    pow_i = pow(2, i)
    ifloat = float(pow_i)

    # Do it 10 times and take an average. 
    total = 0.0
    for i in range (0, 10):
      writeFile("data/temp.txt", pow_i, 1.0 / ifloat)
      writeFile("data/temp2.txt", pow_i, 1.0 / ifloat)
      total = total + callYices()

    avg = total / 10.0
    print (pow_i)
    print str(avg)
    print "\n"

if __name__=="__main__":
  main()
