(* Keep track of how much time we spend doing constraint processing. *)
let constraint_proc_time = ref 0.0
let reset_constraint_time =
  constraint_proc_time := 0.0
let log_constraint_time (new_time : float) =
  constraint_proc_time := !constraint_proc_time +. new_time

(* Keep track of how much time we spend doing evaluation. *)
let exp_proc_time = ref 0.0
let reset_exp_time =
  exp_proc_time := 0.0
let log_exp_time (new_time : float) =
  exp_proc_time := !exp_proc_time +. new_time
