reltype context { viewer :: int }

(* Users. *)
reltype user  { user_id     :: int
              , friends     :: list int }
let users :: relation user = input ("users2048")

function is_friends :: bool (user0 :: int, user1 :: int) = {
  elem(user1, users[user0].friends)
}

reltype photo { photo_id    :: int
              , image       :: int
              , photo_owner :: int
              , tagged      :: list int }
  with (rel) {
    forall r in rel (true)
      (if (is_friends(r.photo_owner, context.viewer))
        then (r.image == ?r.image)
        else (r.image == 1000))
  }
let photos :: relation photo = input ("photo_image")

(* let result :: bool = is_friends(0, 1) *)
(* let result :: int = users[0].friend1 *)
let result :: int = concretize 90 photos[0].image
