(*

*)
(* Track the amount of time we spend solving constraints. *)
let (constraint_time : float ref) = ref 0.0

let update_time (new_time : float) : unit =
  constraint_time := !constraint_time +. new_time
let reset_time () : unit =
  constraint_time := 0.0

let print_time () : unit =
  Printf.printf "%f\n" !constraint_time
