open AstUtils
open BackendInterface
open Error

let eval_elem () = BackendInterface.listElem ()

(* Print has unit return type. *)
let print_exp () =
  BackendInterface.printExp ();
  BackendInterface.pushUnit()

let functions =
  [ "elem", eval_elem
  ; "print", print_exp ]

let evalBuiltinFun f =
  try ((List.assoc f functions) ())
  with _ -> raise (FunctionUndefined f)
