data indata { value :: ~int}
@@ indata {
  increasing value.
}

let input :: relation indata = input data/temp

function average (values :: relation indata) = {
  let sum = 0;

  foreach val in values {
    let sum = sum + val.value;
  }

  return (sum / (length values)); 
}
let result :: int = average input

(* These assertions would generate constraints based on the positions of
   elements in the input relation. *)
(*
@@ indata {
  missing missing_average.
}
*)
