data raildata { city_id   :: int
              , year      :: int
              , compliant :: ~int
              , total     :: ~int
              }
let input_data :: raildata list = input data/rail

@@ input_data {
  missing inc_compliant.
}

function count_total_compliant (rdata :: raildata list) = {
  let total = 0;
  let compliant = 0;
  let year = 2;

  foreach railentry in rdata {
    if (railentry.year == year) {
      let compliant = compliant + railentry.compliant;
      let total = total + railentry.total;
    } else {
      let compliant = compliant;
      let total = total;
    }
  }
  (* return total / totalcompliant *)
}

let result :: int = count_total_compliant input_data
