reltype context { viewer :: int }

reltype album { album_id    :: int
              , album_owner :: int
              , photo0      :: int
              , photo1      :: int }

(* Users. *)
reltype user  { user_id     :: int
              , friends     :: list int }
let users :: relation user = input ("users8192")
function is_friends :: bool (user0 :: int, user1 :: int) = {
  elem(user1, users[user0].friends)
}

reltype photo { photo_id    :: int
              , image       :: int
              , photo_owner :: int
              , tagged      :: list int }
  with (rel) {
    forall r in rel (true)
      (forall u in r.tagged (true)
        (if (is_friends(?u, context.viewer))
          then (u == ?u)
          else (u == 1000)))
  }
let photos :: relation photo = input ("photos")

(* let result :: bool = is_friends(0, 1) *)
(* let result :: int = users[0].friend1 *)
let result :: int = concretize 3 (elem(1, photos[0].tagged))
(* photos[0].image *)
